/*
	Blizzards Plugins Comply With GNU General Public License

	Self Nade Dmg Percent is free software: you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation, either version 3 of the License, or
	(at your option) any later version.
	
	Under no circumstances are you allowed to redistribute and/or modify
	it claming that you are the original author of such plugin/modification.
	
	Self Nade Dmg Percent is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.
	
	You should have received a copy of the GNU General Public License
	along with this program.  If not, see <http://www.gnu.org/licenses/>.
	_____________________________________________________________________
	
	Self Nade Dmg Percent (c) 2013
	=========================
	
	Plugin Thread
	-------------
	https://forums.alliedmods.net/showthread.php?t=216946
	
	Description
	-----------
	This plugin changes the percent of self damage you recieve from a HE Grenade
	To either recieve no dmg( 0 ), half dmg( 50 ) or normal dmg( 100 ) changable via Cvar.
	Handy for when you throw a nade and it bounces back on you.
	
	Cvars
	-----
	amx_nsnp_percent 	"0" - 0% Damage
				"50" - 50% Damage etc
				"100" - 100% Damage etc
	
	Credits
	-------
	Jhob94 		- change cvar to percentage instead of locked amount.
	ConnorMcLeod 	- better checks ( nade specific dmg )
			- take away cvar version 
			- IsPlayer vaild check not needed.
	
	ChangeLog
	---------
	May 29/05/2013 09:06AM
	- v1.0.2 - 	[ ADDED ] HE Nade Specific Check
			[ REMOVED ] version cvar
			[ REMOVED ] attacker being equal to player index
	
	May 28/05/2013 11:49AM
	- v1.0.1 - 	[ EDITED ] changed cvar from locked modes to percent
	
	May 28/05/2013 
	- v1.0.0 - 	Inital Release	
*/

#include < amxmodx >
#include < hamsandwich >

#pragma semicolon 1

#define PLUGIN "Self Nade Dmg Percent"
#define VERSION "1.0.2"
#define AUTHOR "Blizzard"

#define DMG_HEGRENADE     (1 << 24)

// pCvars
new g_pCvar;

public plugin_init() {
	register_plugin( PLUGIN, VERSION, AUTHOR );
	server_print( "^n^t%s v%s, Copyright (C) 2013 by %s^n", PLUGIN, VERSION, AUTHOR );
	
	RegisterHam( Ham_TakeDamage, "player", "Ham_TakeDmgPre", 0 );
	
	g_pCvar = register_cvar( "amx_sndp_percent", "0" );
}

public Ham_TakeDmgPre( id, iInflictor, iAttacker, Float:flDamage, bitsDamageType ) {
	if( id == iAttacker && ( bitsDamageType == DMG_HEGRENADE ) ) {
		SetHamParamFloat( 4, flDamage * get_pcvar_num( g_pCvar ) / 100 );
	}
}
